package com.tptj.demo.hg.export.encrypt;

import com.fr.intelli.record.Focus;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.third.org.bouncycastle.util.Arrays;
import javax.servlet.ServletOutputStream;
import javax.servlet.WriteListener;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.OutputStream;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/15
 **/
@EnableMetrics
public class EncryptOutputStream extends ServletOutputStream {

    private OutputStream original = null;
    private boolean closed = false;
    private ByteArrayOutputStream crypt = new ByteArrayOutputStream();

    public EncryptOutputStream( OutputStream original ){
        this.original = original;
    }

    /**
     * 实际加密的代码就在这里实现了
     * @param bytes
     * @return
     */
    @Focus(id="com.tptj.demo.hg.export.encrypt.v10",text="Export Encrypt")
    private byte[] encrypt(byte[] bytes){
        //假设逆序就是加密了
        return Arrays.reverse(bytes);
    }

    @Override
    public void write(int b) throws IOException {
        if (closed) {
            throw new IOException("Cannot write to a closed output stream");
        }
        crypt.write(b);
    }

    @Override
    public void close() throws IOException {
        if( !closed ){
            byte[] bytes = crypt.toByteArray();
            bytes = encrypt(bytes);
            original.write(bytes);
            original.flush();
            original.close();
            closed = true;
        }
    }

    @Override
    public void flush() throws IOException {
        crypt.flush();
    }

    @Override
    public void write(byte[] data) throws IOException {
        write(data, 0, data.length);
    }

    @Override
    public void write(byte[] data, int off, int len) throws IOException {
        if (closed) {
            throw new IOException("Cannot write to a closed output stream");
        }
        crypt.write(data, off, len);
    }

    @Override
    public boolean isReady() {
        return true;
    }

    @Override
    public void setWriteListener(WriteListener listener) {

    }

}
