package com.tptj.demo.hg.export.encrypt.demo3;

import com.fr.general.IOUtils;
import com.fr.third.org.bouncycastle.util.Arrays;

import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/15
 **/
public class DecryptRequest extends HttpServletRequestWrapper {
    private byte[] data;
    public DecryptRequest(HttpServletRequest request) {
        super(request);
        init();
    }

    private void init(){
        try{
            data = IOUtils.inputStream2Bytes(getRequest().getInputStream());
            //实现解密(假设加密就是逆序，那么解密就是再次逆序即可)
            data = Arrays.reverse(data);
        }catch(Exception e){
            data = new byte[0];
        }
    }

    @Override
    public ServletInputStream getInputStream() throws IOException {
        try{
            return new DelegatingServletInputStream(new ByteArrayInputStream( data ));
        }catch (Exception e){
            return null;
        }
    }

    @Override
    public BufferedReader getReader()throws IOException{
        return new BufferedReader(new InputStreamReader(new ByteArrayInputStream( data )));
    }
}
