package com.tptj.demo.hg.export.encrypt.demo3;

import com.fr.decision.fun.impl.AbstractGlobalRequestFilterProvider;
import com.fr.log.FineLoggerFactory;
import com.fr.stable.StringUtils;
import com.fr.web.utils.WebUtils;

import javax.servlet.FilterChain;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/7/15
 **/

public class Demo extends AbstractGlobalRequestFilterProvider {
    @Override
    public String filterName() {
        return "Export Encrypt";
    }

    @Override
    public String[] urlPatterns() {
        return new String[]{
                "/decision/view/report"
        };
    }

    @Override
    public void doFilter(HttpServletRequest req, HttpServletResponse res, FilterChain chain) {
        String op = WebUtils.getHTTPRequestParameter(req,"op");
        String format = WebUtils.getHTTPRequestParameter(req,"format");
        String cmd = WebUtils.getHTTPRequestParameter(req,"cmd");
        if( "export".equals(op) && StringUtils.isNotEmpty(format)  ){
            //如果是导出，就包裹导出的响应，通过响应中包裹的outputstream进行输出的加密
            res = new EncryptResponse( res );
        }
        if( "fr_write".equals(op) && "imp_w_excel_data".equals(cmd) ){
            //导入excel,包裹请求，读取输入的文件流，先解密，再交给后续的产品处理
            req = new DecryptRequest(req);
        }
        try{
            chain.doFilter(req,res);
        }catch(Exception e){
            FineLoggerFactory.getLogger().error(e,e.getMessage());
        }
    }
}
